Bug 530568 - Review Request: ghmm - A library with data structures and algorithms for Hidden Markov Models
Review Request: ghmm - A library with data structures and algorithms for Hidd...
Status: CLOSED ERRATA
Product: Fedora
Classification: Fedora
Component: Package Review (Show other bugs)
rawhide
All Linux
low Severity medium
: ---
: ---
Assigned To: Thomas Spura
Fedora Extras Quality Assurance
:
Depends On:
Blocks:
  Show dependency treegraph
 
Reported: 2009-10-23 10:07 EDT by D Haley
Modified: 2009-11-07 10:04 EST (History)
4 users (show)

See Also:
Fixed In Version:
Doc Type: Bug Fix
Doc Text:
Story Points: ---
Clone Of:
Environment:
Last Closed: 2009-11-07 06:29:12 EST
Type: ---
Regression: ---
Mount Type: ---
Documentation: ---
CRM:
Verified Versions:
Category: ---
oVirt Team: ---
RHEL 7.3 requirements from Atomic Host:
tomspur: fedora‑review+
kevin: fedora‑cvs+


Attachments (Terms of Use)

  None (edit)
Description D Haley 2009-10-23 10:07:30 EDT
SPEC URL: http://dhd.selfip.com/427e/ghmm-3.spec
SRPM URL: http://dhd.selfip.com/427e/ghmm-0.7-3.svn2286.fc10.src.rpm

Koji
F10:http://koji.fedoraproject.org/koji/taskinfo?taskID=1764453
F11:http://koji.fedoraproject.org/koji/taskinfo?taskID=1764433
F12:http://koji.fedoraproject.org/koji/taskinfo?taskID=1764458

Original Bug report #491490 . Reopening as new owner.

> --disable-static
The SPEC provides a static library subpackage. This would need to be removed, and Having static libraries is kinda nice for some developer users.

>--enable-atlas 
Done.

>You can export CFLAGS in the %configure line with 
>CFLAGS="${RPM_OPT_FLAGS}" %configure --enable-gsl --enable-experimental
>--enable-unsupported
Changed.

The build failure was my fault. I failed to upload the correct SRPM from the x86_64 machine I was working, and instead uploaded an older version. So that should be fixed.

Thanks.
Comment 1 Thomas Spura 2009-10-23 12:21:56 EDT
Currently the tests are failing because the pythonpath are wrong...

with PYTHONPATH=$(PYTHONPATH)+":$RPM_BUILD_ROOT%{python_sitearch} " LD_LIBRARY_PA TH=$RPM_BUILD_ROOT%{_datadir}/ghmm  make check
it's a bit closer to success, but now there are IO warnings:
I/O warning : failed to load external entity "/usr/share/ghmm/ghmm.dtd.1.0"
.I/O warning : failed to load external entity "/usr/share/ghmm/ghmm.dtd.1.0"
I/O warning : failed to load external entity "/usr/share/ghmm/ghmm.dtd.1.0"

Don't know where they try to load that file. Maybe you have more luck ;)


About static libraries:

Ok, but in the guidelines stands "In general, packagers are strongly encouraged not to ship static libs unless a compelling reason exists.". Don't know, if this is a blocker, I need to ask someone else ;)

>You can export CFLAGS in the %configure line with 
>CFLAGS="${RPM_OPT_FLAGS}" %configure --enable-gsl --enable-experimental
>--enable-unsupported

Sorry, my fault %configure already exports exactly this CFLAGS, see:
$ rpm --eval %configure



Package Review
==============

Key:
 - = N/A
 x = Check
 ! = Problem
 ? = Not evaluated

=== REQUIRED ITEMS ===
 [x] Package is named according to the Package Naming Guidelines.
 [!] Spec file name must match the base package %{name}, in the format %{name}.spec.

It is in %{name}-3.spec (probably you won't upload it like this, just as a backup solution, but anyway...).

 [x] Package meets the Packaging Guidelines
 [x] Package successfully compiles and builds into binary rpms on at least one supported architecture.
     Tested on: 
       [] devel/i386 
       [] devel/x86_64
       [] F11/i386 
       [x] F11/x86_64
 [] Rpmlint output:
$ rpmlint ghmm.spec ghmm-0.7-3.svn2286.fc11.src.rpm x86_64/ghmm-*
ghmm.spec:94: W: rpm-buildroot-usage %prep -e 's|$(PYTHON) setup.py install.*$|$(PYTHON) setup.py install -O1 --skip-build --root ${RPM_BUILD_ROOT}|' \
ghmm.src:94: W: rpm-buildroot-usage %prep -e 's|$(PYTHON) setup.py install.*$|$(PYTHON) setup.py install -O1 --skip-build --root ${RPM_BUILD_ROOT}|' \
ghmm.x86_64: W: shared-lib-calls-exit /usr/lib64/libghmm.so.1.0.0 exit@GLIBC_2.2.5
ghmm.x86_64: W: spurious-executable-perm /usr/share/doc/ghmm-0.7/AUTHORS
ghmm-devel.x86_64: W: no-documentation
ghmm-static.x86_64: W: no-documentation
5 packages and 1 specfiles checked; 0 errors, 6 warnings

- The buildroot-usage is ok, shared-lib-calls-exit is notified upstream as stated in spec file.

- spurious-executable-perm /usr/share/doc/ghmm-0.7/AUTHORS


- And AUTHORS is non-utf8, please convert…
http://fedoraproject.org/wiki/PackagingTricks#Convert_encoding_to_UTF-8


 [x] Buildroot is correct
     (%{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n))
 [x] Package is licensed with an open-source compatible license and meets other legal requirements as defined in the legal section of Packaging Guidelines.

Some files have no license header, upstream notified as stated in spec file

 [x] License field in the package spec file matches the actual license.
     License type: LGPLv2+
 [x] If (and only if) the source package includes the text of the license(s) in
its own file, then that file, containing the text of the license(s) for the
package is included in %doc.
 [x] Spec file is legible and written in American English.
 [x] Sources used to build the package matches the upstream source, as provided in the spec URL.
     Upstream source: 5ff2ec84ab3e3877724d332e86fdb88d
     Build source:    24d1829f2562d04115b7f028e0399f0f
But a full diff is clean, this results because the source needed to be generated and timestamps could differ...
ok

 [x] Package is not known to require ExcludeArch
 [x] All build dependencies are listed in BuildRequires, except for any that are listed in the exceptions section of Packaging Guidelines.
 [-] The spec file handles locales properly.
 [x] ldconfig called in %post and %postun if required.
 [x] Package must own all directories that it creates.
 [-] Package requires other packages for directories it uses.
 [x] Package does not contain duplicates in %files.
 [!] Permissions on files are set properly.
see rpmlint output

 [x] Package has a %clean section, which contains rm -rf %{buildroot}.
 [x] Package consistently uses macros.
 [x] Large documentation files are in a -doc subpackage, if required.
 [x] Package uses nothing in %doc for runtime.
 [x] Header files in -devel subpackage, if present.
 [x] Static libraries in -devel subpackage, if present.
 [x] Package requires pkgconfig, if .pc files are present.
 [x] Development .so files in -devel subpackage, if present.
 [x] Fully versioned dependency in subpackages, if present.
 [x] Package does not contain any libtool archives (.la).
 [-] Package contains a properly installed %{name}.desktop file if it is a GUI application.
 [x] Package does not own files or directories owned by other packages.

=== SUGGESTED ITEMS ===
 [x] Latest version is packaged.
     One revision behind trunk, commit is not useful, ok.
 [-] Description and summary sections in the package spec file contains translations for supported Non-English languages, if available.
 [x] Package should compile and build into binary rpms on all supported architectures.
http://koji.fedoraproject.org/koji/taskinfo?taskID=1764745
 [x] Scriptlets must be sane, if used.
 [-] The placement of pkgconfig(.pc) files is correct.



______________________________


issues:
- wait for answer about static libs
- spurious-executable, non-utf-8 > reduce rpmlint output.
- rename spec file to %{name}.spec
- maybe find a way for building the test suite… :(
- delete CFLAGS="${RPM_OPT_FLAGS}" again :(((
Comment 2 Thomas Spura 2009-10-23 12:22:15 EDT
*** Bug 491490 has been marked as a duplicate of this bug. ***
Comment 3 D Haley 2009-10-24 11:24:47 EDT
SPEC URL: http://dhd.selfip.com/427e/ghmm-4.spec
SRPM URL: http://dhd.selfip.com/427e/ghmm-0.7-4.svn2286.fc10.src.rpm

rpmlint:
$ cat tmp
Wrote: /home/makerpm/rpmbuild/SRPMS/ghmm-0.7-4.svn2286.fc10.src.rpm
Wrote: /home/makerpm/rpmbuild/RPMS/i386/ghmm-0.7-4.svn2286.fc10.i386.rpm
Wrote: /home/makerpm/rpmbuild/RPMS/i386/ghmm-static-0.7-4.svn2286.fc10.i386.rpm
Wrote: /home/makerpm/rpmbuild/RPMS/i386/ghmm-devel-0.7-4.svn2286.fc10.i386.rpm
Wrote: /home/makerpm/rpmbuild/RPMS/i386/ghmm-debuginfo-0.7-4.svn2286.fc10.i386.rpm

$ rpmlint `cat tmp | awk '{print $2}'`
ghmm.src:94: W: rpm-buildroot-usage %prep -e 's|$(PYTHON) setup.py install.*$|$(PYTHON) setup.py install -O1 --skip-build --root ${RPM_BUILD_ROOT}|' \
ghmm.i386: W: shared-lib-calls-exit /usr/lib/libghmm.so.1.0.0 exit@GLIBC_2.0
ghmm-static.i386: W: no-documentation
ghmm-devel.i386: W: no-documentation
5 packages and 0 specfiles checked; 0 errors, 4 warnings.
$ sudo rpm -i ../RPMS/i386/ghmm-0.7-4.svn2286.fc10.i386.rpm 
$ rpmlint ghmm
ghmm.i386: W: shared-lib-calls-exit /usr/lib/libghmm.so.1.0.0 exit@GLIBC_2.0
ghmm.i386: W: unused-direct-shlib-dependency /usr/lib/libghmm.so.1.0.0 /usr/lib/libgslcblas.so.0
1 packages and 0 specfiles checked; 0 errors, 2 warnings.

The unused direct-shlib comes from the usage of gsl-config and can be safely ignored.

koji:
F12: http://koji.fedoraproject.org/koji/taskinfo?taskID=1766163


> - wait for answer about static libs
This is not a problem unless the main package ships static libs, and no dependant packages are made that use the -static subpackage -- its for end user-developers only. 

Some discussion on the topic is available here:
http://www.mail-archive.com/fedora-mingw@lists.fedoraproject.org/msg00391.html

>- spurious-executable, non-utf-8 > reduce rpmlint output.
Fixed

>- rename spec file to %{name}.spec
Not required -- name is already %{name}.spec, as seen inside the SRPM. The -revision bit is only how it is loaded onto my webserver. just mv it when you wget/curl it.

>- delete CFLAGS="${RPM_OPT_FLAGS}" again :(((  
Done.

>- maybe find a way for building the test suite… :(
It builds -- but a couple of tests fail, triggering a make failure. Upstream has been notified at https://sourceforge.net/tracker/?func=detail&aid=2842847&group_id=67094&atid=516867, however no response from upstream as yet.


Thanks for the review.
Comment 4 Thomas Spura 2009-10-26 10:01:52 EDT
Hmm, stange, my rpmlint output is a bit different, but less is better anyway ;)

$ rpmlint ghmm.spec ghmm-0.7-4.svn2286.fc11.src.rpm x86_64/ghmm-*
ghmm.spec:94: W: rpm-buildroot-usage %prep -e 's|$(PYTHON) setup.py install.*$|$(PYTHON) setup.py install -O1 --skip-build --root ${RPM_BUILD_ROOT}|' \
ghmm.src:94: W: rpm-buildroot-usage %prep -e 's|$(PYTHON) setup.py install.*$|$(PYTHON) setup.py install -O1 --skip-build --root ${RPM_BUILD_ROOT}|' \
ghmm.x86_64: W: shared-lib-calls-exit /usr/lib64/libghmm.so.1.0.0 exit@GLIBC_2.2.5
ghmm-devel.x86_64: W: no-documentation
ghmm-static.x86_64: W: no-documentation
5 packages and 1 specfiles checked; 0 errors, 5 warnings.


>- rename spec file to %{name}.spec
OK, it looked just a bit strange on the webserver. Now I know, that's normal for you ;)


_____________________________________


APPROVED
Comment 5 D Haley 2009-10-27 01:14:12 EDT
New Package CVS Request
=======================
Package Name: ghmm
Short Description: 
Owners: mycae
Branches: F-11 F-12 EL-5
InitialCC: A library with data structures and algorithms for Hidden Markov Models
Comment 6 D Haley 2009-10-27 01:14:56 EDT
Argg: 


New Package CVS Request
=======================
Package Name: ghmm
Short Description: A library with data structures and algorithms for Hidden Markov
Owners: mycae
Branches: F-11 F-12 EL-5
InitialCC: 
Models
Comment 7 D Haley 2009-10-27 01:15:33 EDT
Argg: 


New Package CVS Request
=======================
Package Name: ghmm
Short Description: A library with data structures and algorithms for Hidden Markov Models  
Owners: mycae
Branches: F-11 F-12 EL-5
InitialCC:
Comment 8 Kevin Fenzi 2009-10-28 20:12:03 EDT
cvs done.
Comment 9 Thomas Spura 2009-11-07 05:06:49 EST
You told 'make update' the old bug number, and not this one, so this will never get closed on its own...

I can't close this right now, because I still can't find this package build in devel...

Did you run a 'make build' in the devel directory?
It seems, you don't; please do so…
Comment 10 D Haley 2009-11-07 05:47:03 EST
>Did you run a 'make build' in the devel directory?
>It seems, you don't; please do so…  
The build was done a week ago:
http://koji.fedoraproject.org/koji/buildinfo?buildID=138832
Comment 12 D Haley 2009-11-07 06:29:12 EST
Its odd that it is not on the webserver.

I can see it in community, though it has some kind of warning on the page "Error loading the data for this page element":
https://admin.fedoraproject.org/community/?package=ghmm#package_maintenance
Comment 13 Mamoru TASAKA 2009-11-07 10:04:47 EST
Note:
The "devel" branch on Fedora CVS and koji (in comment 10) currently points 
to F-13, which is not available on Fedora mirror servers,
while currently "rawhide" (i.e. "development" 
tree on Fedora mirror servers, in comment 11) is for F-12.
dist-f12 (on koji) tree is already locked and now you have to submit push
request for F-12 on bodhi:
https://admin.fedoraproject.org/updates/
and packages for F-12 (currently called as "rawhide") won't appear
until F-12 is formally released.

Note You need to log in before you can comment on or make changes to this bug.